From bda2ca79deaace7e7075300c0c2d8fafc6ac8240 Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jun 19 2019 20:28:03 +0000
Subject: [PATCH 2/3] fix bug on total recalculation


---

diff --git a/build_stats.py b/build_stats.py
index 4cb3d89..442ad61 100755
--- a/build_stats.py
+++ b/build_stats.py
@@ -5,12 +5,13 @@ import argparse
 import os
 import pandas
 
-result_folder = ""
+RESULT_FOLDER = ""
+
 
 def main():
     """Handle params"""
 
-    global result_folder
+    global RESULT_FOLDER
 
     parser = argparse.ArgumentParser(
         description="Consolidate every result files and produce a clean concatenated update")
@@ -19,9 +20,9 @@ def main():
 
     args = parser.parse_args()
 
-    result_folder = "./results/"+args.version
+    RESULT_FOLDER = "./results/"+args.version
 
-    file = result_folder +"/_concat.csv"
+    file = RESULT_FOLDER + "/_concat.csv"
     parse(file)
 
 
@@ -206,7 +207,8 @@ def clean_bcp47(data):
     # set types
     data.territory = data.territory.fillna('')
     data.script = data.script.fillna('')
-    data = data.astype({'territory': 'str', 'language': 'str', 'script': 'str'})
+    data = data.astype(
+        {'territory': 'str', 'language': 'str', 'script': 'str'})
 
     return data
 
@@ -239,6 +241,8 @@ def add_cldr(data):
     data = data.rename(columns={'name': 'territory_name'})
     data = data.drop('code', 1)
 
+    data['full_language_code'] = data.apply(get_full_language_code, axis=1)
+
     return data
 
 
@@ -252,6 +256,7 @@ def clean_cldr(data):
 
     return data
 
+
 def check_lang_territory_consistency(data):
     """ use pop per lang_script and territory to detect potential errors """
 
@@ -260,18 +265,19 @@ def check_lang_territory_consistency(data):
     cldr_data.CName = cldr_data.CName.str.lower()
 
     # in this file, Azerbaijani (Arabic) is written az_Arab, we only keep lang for now
-    cldr_data['Language'] = cldr_data['Language'].str.rsplit('_', 1, expand=True)[0]
-
+    cldr_data['Language'] = cldr_data['Language'].str.rsplit('_', 1, expand=True)[
+        0]
 
     cldr_data = cldr_data[["CName", 'Language']]
     # as we may have duplicated values now
     cldr_data = cldr_data.drop_duplicates()
-    cldr_data = cldr_data.rename(columns={'CName':'terr', 'Language':'language'})
+    cldr_data = cldr_data.rename(
+        columns={'CName': 'terr', 'Language': 'language'})
 
     data = data.merge(cldr_data, how='left',
-                      left_on=('language','territory'),
-                      right_on=('language','terr'),
-                      suffixes=(False,'_cldr'))
+                      left_on=('language', 'territory'),
+                      right_on=('language', 'terr'),
+                      suffixes=(False, '_cldr'))
 
     error = data[['language', 'territory', 'terr']]
     error = error[~(error.territory.isnull())]
@@ -283,37 +289,66 @@ def check_lang_territory_consistency(data):
 
     return data
 
-def harmonize_totals(data):
-    """ po files may be outdate, hypothese: max(source string)=truth"""
 
-    #miaw = data.groupby(['src'], sort=False)
-    #miaw['totalMessage_max'] = miaw['totalMessage'].max()
+def get_full_language_code(row):
+    """ full language code using this naming: lang_territory@script """
+    val = row.language
+    if row.territory:
+        val = val + "_" + row.territory
+    if row.script:
+        val = val + "@" + row.script
+
+    return val
+
 
+def clean_dirname(row):
+    """ strip full_language_code from dirname """
+    val = row.dirname
+
+    if val.endswith(row.full_language_code):
+        val = row.dirname[:-len(row.full_language_code)]
+
+    return val
+
+
+def harmonize_totals(data):
+    """ po files may be outdate, hypothese: max(source string)=truth"""
     # there could be multiple translation files for one language on a same project
     data['dirname'] = data['filename'].apply(os.path.dirname)
 
-    max = data.groupby(['src','dirname'], sort=False)['totalMessage'].max().rename("totalMessageMax").reset_index()
-    data = data.merge(max)
-    #data['untranslatedMessages'] += data['totalMessageMax'] - data['totalMessage']
+    # sometimes, the $lang.po file is inside a $lang folder, remove this
+    data['dirname'] = data.apply(clean_dirname, axis=1)
 
+    # calculate the real totalMessage
+    tmp = data.groupby(['src', 'dirname'])['totalMessage'].max().rename(
+        "totalMessageMax").reset_index()
+    data = data.merge(tmp)
+    data['untranslatedMessages'] += data['totalMessageMax'] - data['totalMessage']
+    data['totalMessage'] = data['totalMessageMax']
 
-    max = data.groupby(['src','dirname'], sort=False)['totalSourceWords'].max().rename("totalSourceWordsMax").reset_index()
-    data = data.merge(max)
-    #data['untranslatedSourceWords'] += data['totalSourceWordsMax'] - data['totalSourceWords']
+    # calculate the real totalSourceWords
+    tmp = data.groupby(['src', 'dirname'])['totalSourceWords'].max().rename(
+        "totalSourceWordsMax").reset_index()
+    data = data.merge(tmp)
+    data['untranslatedSourceWords'] += data['totalSourceWordsMax'] - \
+        data['totalSourceWords']
+    data['totalSourceWords'] = data['totalSourceWordsMax']
 
-    #data = data.drop('totalMessageMax', 1)
-    #data = data.drop('totalSourceWordsMax', 1)
+    data = data.drop('totalMessageMax', 1)
+    data = data.drop('totalSourceWordsMax', 1)
 
     return data
 
+
 def summary(data):
 
-    stat1 = data[['language', 'territory', 'script']].drop_duplicates().count().max()
+    stat1 = data[['language', 'territory', 'script']
+                 ].drop_duplicates().count().max()
     stat2 = data['src'].drop_duplicates().count()
     stat3 = data[['src', 'filename']].drop_duplicates().count().max()
     stat4 = data['language'].drop_duplicates().count()
-    stat5 = data.groupby(['src','dirname'])['totalMessageMax'].max().sum()
-    stat6 = data.groupby(['src','dirname'])['totalSourceWordsMax'].max().sum()
+    stat5 = data.groupby(['src', 'dirname'])['totalMessage'].max().sum()
+    stat6 = data.groupby(['src', 'dirname'])['totalSourceWords'].max().sum()
 
     print("")
     print("We have:")
@@ -328,6 +363,7 @@ def summary(data):
 
     return data
 
+
 def info(dataset, step):
     """Print basic informations about current dataset"""
     print(" * "+step+" → we now have "+str(len(dataset))+" rows")
@@ -335,8 +371,8 @@ def info(dataset, step):
 
 def store(dataset, name):
     """Store dataset to csv"""
-    global result_folder
-    dataset.to_csv(result_folder+"/"+name, index=False)
+    global RESULT_FOLDER
+    dataset.to_csv(RESULT_FOLDER+"/"+name, index=False)
 
 
 if __name__ == '__main__':

